From 8901a1d8a81896900c10aca78cbc15ba0bee4a9b Mon Sep 17 00:00:00 2001
From: Paul Eggert <eggert@cs.ucla.edu>
Date: Mon, 6 Jun 2016 10:10:06 -0700
Subject: [PATCH] Fix crash in syntax.c after GC
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Problem reported by Vincent Belaïche (Bug#23704).
* src/syntax.c (skip_chars): Call SETUP_SYNTAX_TABLE,
which can GC, before computing pointers into the buffer.
---
 src/syntax.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/src/syntax.c b/src/syntax.c
index 16b7fab..c59b668 100644
--- a/src/syntax.c
+++ b/src/syntax.c
@@ -2171,6 +2171,8 @@ skip_syntaxes (bool forwardp, Lisp_Object string, Lisp_Object lim)
     ptrdiff_t start_point = PT;
     ptrdiff_t pos = PT;
     ptrdiff_t pos_byte = PT_BYTE;
+    immediate_quit = 1;
+    SETUP_SYNTAX_TABLE (pos, forwardp ? 1 : -1);
     unsigned char *p = PT_ADDR, *endp, *stop;
 
     if (forwardp)
@@ -2184,8 +2186,6 @@ skip_syntaxes (bool forwardp, Lisp_Object string, Lisp_Object lim)
 	stop = (pos >= GPT && GPT > XINT (lim)) ? GAP_END_ADDR : endp;
       }
 
-    immediate_quit = 1;
-    SETUP_SYNTAX_TABLE (pos, forwardp ? 1 : -1);
     if (forwardp)
       {
 	if (multibyte)
-- 
2.5.5

